package sun.security.x509;

import sun.security.util.DerOutputStream;
import sun.security.util.Debug;
import java.io.InputStream;
import sun.security.util.DerInputStream;
import java.io.IOException;
import sun.security.util.DerValue;
import java.math.BigInteger;

public class SerialNumber
{
    private BigInteger serialNum;
    
    private void construct(DerValue derValue) throws IOException {
        this.serialNum = derValue.getBigInteger();
        if (derValue.data.available() != 0) {
            throw new IOException("Excess SerialNumber data");
        }
        return;
    }
    
    public SerialNumber(BigInteger serialNum) {
        this.serialNum = serialNum;
    }
    
    public SerialNumber(int n) {
        this.serialNum = BigInteger.valueOf((long)n);
    }
    
    public SerialNumber(DerInputStream derInputStream) throws IOException {
        this.construct(derInputStream.getDerValue());
    }
    
    public SerialNumber(DerValue derValue) throws IOException {
        this.construct(derValue);
    }
    
    public SerialNumber(InputStream in) throws IOException {
        this.construct(new DerValue(in));
    }
    
    @Override
    public String toString() {
        return "SerialNumber: [" + Debug.toHexString(this.serialNum) + "]";
    }
    
    public void encode(DerOutputStream derOutputStream) throws IOException {
        derOutputStream.putInteger(this.serialNum);
    }
    
    public BigInteger getNumber() {
        return this.serialNum;
    }
}
